module jp.ku6.bitmap.core;

/++
 + ビットマップデータのインターフェース
 +/
interface Bitmap
{
	@property
	{
		/// 画像の幅
		uint width();

		/// 画像の高さ
		uint height();
	}

	/++
	 + ファイルをオープン
	 +
	 + Returns:
	 +  成功した場合にtrueを返す
	 +/
	bool open();

	/++
	 + ファイルをクローズ
	 +/
	void close();

	/++
	 + データをメモリにロード
	 +
	 + Returns:
	 +  展開されたデータ
	 +/
	uint[] readAsTrueColor();

	/++
	 + データをメモリにロード
	 +
	 + Params:
	 +  destination = 展開先メモリのポインタ
	 +  width = 展開先メモリ領域の幅
	 +  height = 展開先メモリ領域の高さ
	 +
	 + Returns:
	 +  データが書き込まれ、destinationが返される
	 +  失敗時にはnullを返す
	 +/
	uint[] readAsTrueColor(uint[] destination, uint destinationWidth, uint destinationHeight);
}

