module jp.ku6.pmdloader.winmain;

import core.runtime;
import core.thread;
import std.file;
import jp.ku6.windows.win32api.windows;
import jp.ku6.windows.win32api.winuser;
import jp.ku6.windows.game.application;
import jp.ku6.windows.game.input;
import jp.ku6.pmdloader.pmdloader;

//--------------------------------------------------------------
// D言語でWindowsアプリを作るときの基本処理

extern (Windows)
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	int result;

	Runtime.initialize();

	// コマンドライン引数を解析
	string[] arguments = parseCommandLine(lpCmdLine);
	if (arguments.length > 0)
	{
		// ファイルが渡されていたら処理を行う
		if (std.file.exists(arguments[0]) && std.file.isfile(arguments[0]))
		{
			// アプリケーションの基本設定
			Application.startup(hInstance, 640, 480, "PMD Loader", "PMD Loader", null, null, null);

			try
			{
				// 入力初期化と終了
				Input.startup();
				scope (exit) Input.shutdown();

				auto pmdLoader = new PmdLoader(executeDirectory(hInstance), arguments[0]);

				while (Application.instance().isValid())
					pmdLoader.mainLoop();

				delete pmdLoader;
			}
			catch (Throwable o)
			{
				MessageBoxA(null, cast(char*)o.toString(), "Error", MB_OK | MB_ICONEXCLAMATION);
				result = 1;
			}

			Application.shutdown();
		}
	}

	Runtime.terminate();

	return result;
}
